diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/test/wifi-mac-queue-test.cc ns-3.34/src/wifi/test/wifi-mac-queue-test.cc
--- ns-3.33/src/wifi/test/wifi-mac-queue-test.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/test/wifi-mac-queue-test.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,128 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2021 IITP RAS
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Alexander Krotov <krotov@iitp.ru>
+ */
+
+#include "ns3/test.h"
+#include "ns3/wifi-mac-queue.h"
+#include "ns3/simulator.h"
+
+using namespace ns3;
+
+/**
+ * \ingroup wifi-test
+ * \ingroup tests
+ *
+ * \brief Test DROP_OLDEST setting.
+ *
+ * This test verifies the correctness of DROP_OLDEST policy when packets
+ * are pushed into the front of the queue. This case is not handled
+ * by the underlying ns3::Queue<WifiMacQueueItem>.
+ */
+class WifiMacQueueDropOldestTest : public TestCase
+{
+public:
+  /**
+   * \brief Constructor
+   */
+  WifiMacQueueDropOldestTest ();
+
+  void DoRun () override;
+};
+
+WifiMacQueueDropOldestTest::WifiMacQueueDropOldestTest()
+  : TestCase ("Test DROP_OLDEST setting")
+{
+}
+
+void
+WifiMacQueueDropOldestTest::DoRun ()
+{
+  auto wifiMacQueue = CreateObject<WifiMacQueue> ();
+  wifiMacQueue->SetMaxSize (QueueSize ("5p"));
+  wifiMacQueue->SetAttribute ("DropPolicy", EnumValue (WifiMacQueue::DROP_OLDEST));
+
+  // Initialize the queue with 5 packets.
+  std::vector<uint64_t> packetUids;
+  for (uint32_t i = 0; i < 5; i++)
+    {
+      WifiMacHeader header;
+      header.SetType (WIFI_MAC_QOSDATA);
+      header.SetQosTid (0);
+      auto packet = Create<Packet> ();
+      auto item = Create<WifiMacQueueItem> (packet, header);
+      wifiMacQueue->PushFront (item);
+
+      packetUids.push_back (packet->GetUid ());
+    }
+
+  // Check that all elements are inserted successfully.
+  auto it = wifiMacQueue->begin ();
+  NS_TEST_EXPECT_MSG_EQ (wifiMacQueue->GetNPackets (), 5, "Queue has unexpected number of elements");
+  for (uint32_t i = 5; i > 0; i--)
+    {
+      NS_TEST_EXPECT_MSG_EQ ((*it)->GetPacket ()->GetUid (),
+                             packetUids.at (i - 1),
+                             "Stored packet is not the expected one");
+      it++;
+    }
+
+  // Push another element in front of the queue.
+  WifiMacHeader header;
+  header.SetType (WIFI_MAC_QOSDATA);
+  header.SetQosTid (0);
+  auto packet = Create<Packet> ();
+  auto item = Create<WifiMacQueueItem> (packet, header);
+  wifiMacQueue->PushFront (item);
+
+  // Update the vector of expected packet UIDs.
+  packetUids.at (4) = packet->GetUid ();
+
+  // Check that front packet was replaced correctly.
+  it = wifiMacQueue->begin ();
+  NS_TEST_EXPECT_MSG_EQ (wifiMacQueue->GetNPackets (), 5, "Queue has unexpected number of elements");
+  for (uint32_t i = 5; i > 0; i--)
+    {
+      NS_TEST_EXPECT_MSG_EQ ((*it)->GetPacket ()->GetUid (),
+                             packetUids.at (i - 1),
+                             "Stored packet is not the expected one");
+      it++;
+    }
+
+  Simulator::Destroy ();
+}
+
+/**
+ * \ingroup wifi-test
+ * \ingroup tests
+ *
+ * \brief Wifi MAC Queue Test Suite
+ */
+class WifiMacQueueTestSuite : public TestSuite
+{
+  public:
+    WifiMacQueueTestSuite ();
+};
+
+WifiMacQueueTestSuite::WifiMacQueueTestSuite ()
+  : TestSuite ("wifi-mac-queue", UNIT)
+{
+  AddTestCase (new WifiMacQueueDropOldestTest, TestCase::QUICK);
+}
+
+static WifiMacQueueTestSuite g_wifiMacQueueTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/test/wifi-phy-ofdma-test.cc ns-3.34/src/wifi/test/wifi-phy-ofdma-test.cc
--- ns-3.33/src/wifi/test/wifi-phy-ofdma-test.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/test/wifi-phy-ofdma-test.cc	2021-07-14 10:31:07.000000000 -0700
@@ -22,6 +22,7 @@
 #include "ns3/test.h"
 #include "ns3/node.h"
 #include "ns3/pointer.h"
+#include "ns3/string.h"
 #include "ns3/simulator.h"
 #include "ns3/rng-seed-manager.h"
 #include "ns3/constant-position-mobility-model.h"
@@ -33,18 +34,34 @@
 #include "ns3/wifi-mac-header.h"
 #include "ns3/wifi-net-device.h"
 #include "ns3/wifi-psdu.h"
-#include "ns3/wifi-ppdu.h"
+#include "ns3/he-ppdu.h"
+#include "ns3/wifi-utils.h"
+#include "ns3/ap-wifi-mac.h"
+#include "ns3/sta-wifi-mac.h"
+#include "ns3/he-configuration.h"
+#include "ns3/ctrl-headers.h"
+#include "ns3/threshold-preamble-detection-model.h"
+#include "ns3/he-phy.h"
 #include "ns3/waveform-generator.h"
 #include "ns3/non-communicating-net-device.h"
+#include "ns3/spectrum-wifi-helper.h"
+#include "ns3/mobility-helper.h"
 
 using namespace ns3;
 
 NS_LOG_COMPONENT_DEFINE ("WifiPhyOfdmaTest");
 
+static const uint8_t DEFAULT_CHANNEL_NUMBER = 36;
 static const uint32_t DEFAULT_FREQUENCY = 5180; // MHz
+static const WifiPhyBand DEFAULT_WIFI_BAND = WIFI_PHY_BAND_5GHZ;
 static const uint16_t DEFAULT_CHANNEL_WIDTH = 20; // MHz
+static const uint16_t DEFAULT_GUARD_WIDTH = DEFAULT_CHANNEL_WIDTH; // MHz (expanded to channel width to model spectrum mask)
 
-class OfdmaSpectrumWifiPhy : public SpectrumWifiPhy
+/**
+ * HE PHY slightly modified so as to return a given
+ * STA-ID in case of DL MU for OfdmaSpectrumWifiPhy.
+ */
+class OfdmaTestHePhy : public HePhy
 {
 public:
   /**
@@ -52,35 +69,231 @@
    *
    * \param staId the ID of the STA to which this PHY belongs to
    */
-  OfdmaSpectrumWifiPhy (uint16_t staId);
-  virtual ~OfdmaSpectrumWifiPhy ();
+  OfdmaTestHePhy (uint16_t staId);
+  virtual ~OfdmaTestHePhy ();
 
-private:
   /**
    * Return the STA ID that has been assigned to the station this PHY belongs to.
    * This is typically called for MU PPDUs, in order to pick the correct PSDU.
    *
+   * \param ppdu the PPDU for which the STA ID is requested
    * \return the STA ID
    */
-  uint16_t GetStaId (void) const override;
+  uint16_t GetStaId (const Ptr<const WifiPpdu> ppdu) const override;
+
+  /**
+   * Set the global PPDU UID counter.
+   *
+   * \param uid the value to which the global PPDU UID counter should be set
+   */
+  void SetGlobalPpduUid (uint64_t uid);
 
+private:
   uint16_t m_staId; ///< ID of the STA to which this PHY belongs to
-};
+}; //class OfdmaTestHePhy
 
-OfdmaSpectrumWifiPhy::OfdmaSpectrumWifiPhy (uint16_t staId)
-  : SpectrumWifiPhy (),
+OfdmaTestHePhy::OfdmaTestHePhy (uint16_t staId)
+  : HePhy (),
     m_staId (staId)
 {
 }
 
+OfdmaTestHePhy::~OfdmaTestHePhy ()
+{
+}
+
+uint16_t
+OfdmaTestHePhy::GetStaId (const Ptr<const WifiPpdu> ppdu) const
+{
+  if (ppdu->GetType () == WIFI_PPDU_TYPE_DL_MU)
+    {
+      return m_staId;
+    }
+  return HePhy::GetStaId (ppdu);
+}
+
+void
+OfdmaTestHePhy::SetGlobalPpduUid (uint64_t uid)
+{
+  m_globalPpduUid = uid;
+}
+
+/**
+ * SpectrumWifiPhy used for testing OFDMA.
+ */
+class OfdmaSpectrumWifiPhy : public SpectrumWifiPhy
+{
+public:
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+  /**
+   * Constructor
+   *
+   * \param staId the ID of the STA to which this PHY belongs to
+   */
+  OfdmaSpectrumWifiPhy (uint16_t staId);
+  virtual ~OfdmaSpectrumWifiPhy ();
+
+  void DoInitialize (void) override;
+  void DoDispose (void) override;
+
+  using WifiPhy::Reset;
+
+  /**
+   * TracedCallback signature for UID of transmitted PPDU.
+   *
+   * \param uid the UID of the transmitted PPDU
+   */
+  typedef void (*TxPpduUidCallback)(uint64_t uid);
+
+  /**
+   * \param ppdu the PPDU to send
+   */
+  void StartTx (Ptr<WifiPpdu> ppdu) override;
+  /**
+   * \param currentChannelWidth channel width of the current transmission (MHz)
+   * \return the width of the guard band (MHz) set to 2
+   */
+  uint16_t GetGuardBandwidth (uint16_t currentChannelWidth) const override;
+
+  /**
+   * Set the global PPDU UID counter.
+   *
+   * \param uid the value to which the global PPDU UID counter should be set
+   */
+  void SetPpduUid (uint64_t uid);
+
+  /**
+   * Since we assume trigger frame was previously received from AP, this is used to set its UID
+   *
+   * \param uid the PPDU UID of the trigger frame
+   */
+  void SetTriggerFrameUid (uint64_t uid);
+
+  /**
+   * \return the current preamble events map
+   */
+  std::map <std::pair<uint64_t, WifiPreamble>, Ptr<Event> > & GetCurrentPreambleEvents (void);
+  /**
+   * \return the current event
+   */
+  Ptr<Event> GetCurrentEvent (void);
+
+  /**
+   * Wrapper to InterferenceHelper method.
+   *
+   * \param energyW the minimum energy (W) requested
+   * \param band identify the requested band
+   *
+   * \returns the expected amount of time the observed
+   *          energy on the medium for a given band will
+   *          be higher than the requested threshold.
+   */
+  Time GetEnergyDuration (double energyW, WifiSpectrumBand band);
+
+  /**
+   * \return a const pointer to the HE PHY instance
+   */
+  Ptr<const HePhy> GetHePhy (void) const;
+
+private:
+  Ptr<OfdmaTestHePhy> m_ofdmTestHePhy; ///< Pointer to HE PHY instance used for OFDMA test
+  TracedCallback<uint64_t> m_phyTxPpduUidTrace; //!< Callback providing UID of the PPDU that is about to be transmitted
+}; //class OfdmaSpectrumWifiPhy
+
+TypeId
+OfdmaSpectrumWifiPhy::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::OfdmaSpectrumWifiPhy")
+    .SetParent<SpectrumWifiPhy> ()
+    .SetGroupName ("Wifi")
+    .AddTraceSource ("TxPpduUid",
+                     "UID of the PPDU to be transmitted",
+                     MakeTraceSourceAccessor (&OfdmaSpectrumWifiPhy::m_phyTxPpduUidTrace),
+                     "ns3::OfdmaSpectrumWifiPhy::TxPpduUidCallback")
+  ;
+  return tid;
+}
+
+OfdmaSpectrumWifiPhy::OfdmaSpectrumWifiPhy (uint16_t staId)
+  : SpectrumWifiPhy ()
+{
+  m_ofdmTestHePhy = Create<OfdmaTestHePhy> (staId);
+  m_ofdmTestHePhy->SetOwner (this);
+}
+
 OfdmaSpectrumWifiPhy::~OfdmaSpectrumWifiPhy()
 {
 }
 
+void
+OfdmaSpectrumWifiPhy::DoInitialize (void)
+{
+  //Replace HE PHY instance with test instance
+  m_phyEntities[WIFI_MOD_CLASS_HE] = m_ofdmTestHePhy;
+  SpectrumWifiPhy::DoInitialize ();
+}
+
+void
+OfdmaSpectrumWifiPhy::DoDispose (void)
+{
+  m_ofdmTestHePhy = 0;
+  SpectrumWifiPhy::DoDispose ();
+}
+
+void
+OfdmaSpectrumWifiPhy::SetPpduUid (uint64_t uid)
+{
+  m_ofdmTestHePhy->SetGlobalPpduUid (uid);
+  m_previouslyRxPpduUid = uid;
+}
+
+void
+OfdmaSpectrumWifiPhy::SetTriggerFrameUid (uint64_t uid)
+{
+  m_previouslyRxPpduUid = uid;
+}
+
+void
+OfdmaSpectrumWifiPhy::StartTx (Ptr<WifiPpdu> ppdu)
+{
+  m_phyTxPpduUidTrace (ppdu->GetUid ());
+  SpectrumWifiPhy::StartTx (ppdu);
+}
+
+std::map <std::pair<uint64_t, WifiPreamble>, Ptr<Event> > &
+OfdmaSpectrumWifiPhy::GetCurrentPreambleEvents (void)
+{
+  return m_currentPreambleEvents;
+}
+
 uint16_t
-OfdmaSpectrumWifiPhy::GetStaId (void) const
+OfdmaSpectrumWifiPhy::GetGuardBandwidth (uint16_t currentChannelWidth) const
+{
+  // return a small enough value to avoid having too much out of band transmission
+  // knowing that slopes are not configurable yet.
+  return 1;
+}
+
+Ptr<Event>
+OfdmaSpectrumWifiPhy::GetCurrentEvent (void)
+{
+  return m_currentEvent;
+}
+
+Time
+OfdmaSpectrumWifiPhy::GetEnergyDuration (double energyW, WifiSpectrumBand band)
+{
+  return m_interference.GetEnergyDuration (energyW, band);
+}
+
+Ptr<const HePhy>
+OfdmaSpectrumWifiPhy::GetHePhy (void) const
 {
-  return m_staId;
+  return DynamicCast<const HePhy> (GetPhyEntity (WIFI_MOD_CLASS_HE));
 }
 
 /**
@@ -96,33 +309,37 @@
   virtual ~TestDlOfdmaPhyTransmission ();
 
 private:
-  virtual void DoSetup (void);
-  virtual void DoRun (void);
+  void DoSetup (void) override;
+  void DoTeardown (void) override;
+  void DoRun (void) override;
 
   /**
    * Receive success function for STA 1
    * \param psdu the PSDU
-   * \param snr the SNR
+   * \param rxSignalInfo the info on the received signal (\see RxSignalInfo)
    * \param txVector the transmit vector
    * \param statusPerMpdu reception status per MPDU
    */
-  void RxSuccessSta1 (Ptr<WifiPsdu> psdu, double snr, WifiTxVector txVector, std::vector<bool> statusPerMpdu);
+  void RxSuccessSta1 (Ptr<WifiPsdu> psdu, RxSignalInfo rxSignalInfo,
+                      WifiTxVector txVector, std::vector<bool> statusPerMpdu);
   /**
    * Receive success function for STA 2
    * \param psdu the PSDU
-   * \param snr the SNR
+   * \param rxSignalInfo the info on the received signal (\see RxSignalInfo)
    * \param txVector the transmit vector
    * \param statusPerMpdu reception status per MPDU
    */
-  void RxSuccessSta2 (Ptr<WifiPsdu> psdu, double snr, WifiTxVector txVector, std::vector<bool> statusPerMpdu);
+  void RxSuccessSta2 (Ptr<WifiPsdu> psdu, RxSignalInfo rxSignalInfo,
+                      WifiTxVector txVector, std::vector<bool> statusPerMpdu);
   /**
    * Receive success function for STA 3
    * \param psdu the PSDU
-   * \param snr the SNR
+   * \param rxSignalInfo the info on the received signal (\see RxSignalInfo)
    * \param txVector the transmit vector
    * \param statusPerMpdu reception status per MPDU
    */
-  void RxSuccessSta3 (Ptr<WifiPsdu> psdu, double snr, WifiTxVector txVector, std::vector<bool> statusPerMpdu);
+  void RxSuccessSta3 (Ptr<WifiPsdu> psdu, RxSignalInfo rxSignalInfo,
+                      WifiTxVector txVector, std::vector<bool> statusPerMpdu);
 
   /**
    * Receive failure function for STA 1
@@ -260,7 +477,7 @@
 {
   NS_LOG_FUNCTION (this << rxStaId1 << rxStaId2);
   WifiConstPsduMap psdus;
-  WifiTxVector txVector = WifiTxVector (WifiPhy::GetHeMcs7 (), 0, WIFI_PREAMBLE_HE_MU, 800, 1, 1, 0, m_channelWidth, false, false);
+  WifiTxVector txVector = WifiTxVector (HePhy::GetHeMcs7 (), 0, WIFI_PREAMBLE_HE_MU, 800, 1, 1, 0, m_channelWidth, false, false);
   HeRu::RuType ruType = HeRu::RU_106_TONE;
   if (m_channelWidth == 20)
     {
@@ -283,20 +500,14 @@
       NS_ASSERT_MSG (false, "Unsupported channel width");
     }
   
-  HeRu::RuSpec ru1;
-  ru1.primary80MHz = true;
-  ru1.ruType = ruType;
-  ru1.index = 1;
+  HeRu::RuSpec ru1 (ruType, 1, true);
   txVector.SetRu (ru1, rxStaId1);
-  txVector.SetMode (WifiPhy::GetHeMcs7 (), rxStaId1);
+  txVector.SetMode (HePhy::GetHeMcs7 (), rxStaId1);
   txVector.SetNss (1, rxStaId1);
 
-  HeRu::RuSpec ru2;
-  ru2.primary80MHz = (m_channelWidth == 160) ? false : true;
-  ru2.ruType = ruType;
-  ru2.index = 2;
+  HeRu::RuSpec ru2 (ruType, (m_channelWidth == 160 ? 1 : 2), (m_channelWidth == 160 ? false : true));
   txVector.SetRu (ru2, rxStaId2);
-  txVector.SetMode (WifiPhy::GetHeMcs9 (), rxStaId2);
+  txVector.SetMode (HePhy::GetHeMcs9 (), rxStaId2);
   txVector.SetNss (1, rxStaId2);
 
   Ptr<Packet> pkt1 = Create<Packet> (1000);
@@ -337,33 +548,31 @@
 
 TestDlOfdmaPhyTransmission::~TestDlOfdmaPhyTransmission ()
 {
-  m_phyAp = 0;
-  m_phySta1 = 0;
-  m_phySta2 = 0;
-  m_phySta3 = 0;
-  m_phyInterferer = 0;
 }
 
 void
-TestDlOfdmaPhyTransmission::RxSuccessSta1 (Ptr<WifiPsdu> psdu, double snr, WifiTxVector txVector, std::vector<bool> /*statusPerMpdu*/)
+TestDlOfdmaPhyTransmission::RxSuccessSta1 (Ptr<WifiPsdu> psdu, RxSignalInfo rxSignalInfo,
+                                           WifiTxVector txVector, std::vector<bool> /*statusPerMpdu*/)
 {
-  NS_LOG_FUNCTION (this << *psdu << snr << txVector);
+  NS_LOG_FUNCTION (this << *psdu << rxSignalInfo << txVector);
   m_countRxSuccessSta1++;
   m_countRxBytesSta1 += (psdu->GetSize () - 30);
 }
 
 void
-TestDlOfdmaPhyTransmission::RxSuccessSta2 (Ptr<WifiPsdu> psdu, double snr, WifiTxVector txVector, std::vector<bool> /*statusPerMpdu*/)
+TestDlOfdmaPhyTransmission::RxSuccessSta2 (Ptr<WifiPsdu> psdu, RxSignalInfo rxSignalInfo,
+                                           WifiTxVector txVector, std::vector<bool> /*statusPerMpdu*/)
 {
-  NS_LOG_FUNCTION (this << *psdu << snr << txVector);
+  NS_LOG_FUNCTION (this << *psdu << rxSignalInfo << txVector);
   m_countRxSuccessSta2++;
   m_countRxBytesSta2 += (psdu->GetSize () - 30);
 }
 
 void
-TestDlOfdmaPhyTransmission::RxSuccessSta3 (Ptr<WifiPsdu> psdu, double snr, WifiTxVector txVector, std::vector<bool> /*statusPerMpdu*/)
+TestDlOfdmaPhyTransmission::RxSuccessSta3 (Ptr<WifiPsdu> psdu, RxSignalInfo rxSignalInfo,
+                                           WifiTxVector txVector, std::vector<bool> /*statusPerMpdu*/)
 {
-  NS_LOG_FUNCTION (this << *psdu << snr << txVector);
+  NS_LOG_FUNCTION (this << *psdu << rxSignalInfo << txVector);
   m_countRxSuccessSta3++;
   m_countRxBytesSta3 += (psdu->GetSize () - 30);
 }
@@ -515,6 +724,21 @@
 }
 
 void
+TestDlOfdmaPhyTransmission::DoTeardown (void)
+{
+  m_phyAp->Dispose ();
+  m_phyAp = 0;
+  m_phySta1->Dispose ();
+  m_phySta1 = 0;
+  m_phySta2->Dispose ();
+  m_phySta2 = 0;
+  m_phySta3->Dispose ();
+  m_phySta3 = 0;
+  m_phyInterferer->Dispose ();
+  m_phyInterferer = 0;
+}
+
+void
 TestDlOfdmaPhyTransmission::RunOne (void)
 {
   RngSeedManager::SetSeed (1);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/test/wifi-phy-ofdma-test.cc ns-3.34/src/wifi/test/wifi-phy-ofdma-test.cc
--- ns-3.33/src/wifi/test/wifi-phy-ofdma-test.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/test/wifi-phy-ofdma-test.cc	2021-07-14 10:31:07.000000000 -0700
@@ -738,6 +3656,11 @@
   : TestSuite ("wifi-phy-ofdma", UNIT)
 {
   AddTestCase (new TestDlOfdmaPhyTransmission, TestCase::QUICK);
+  AddTestCase (new TestUlOfdmaPpduUid, TestCase::QUICK);
+  AddTestCase (new TestMultipleHeTbPreambles, TestCase::QUICK);
+  AddTestCase (new TestUlOfdmaPhyTransmission, TestCase::QUICK);
+  AddTestCase (new TestPhyPaddingExclusion, TestCase::QUICK);
+  AddTestCase (new TestUlOfdmaPowerControl, TestCase::QUICK);
 }
 
 static WifiPhyOfdmaTestSuite wifiPhyOfdmaTestSuite; ///< the test suite
